import {throwIfAppliedToNonStaticProperty, getPolymerPropertyObject} from './utils';

export function computed(observedProps, computedFn) {
  return (klass, propertyKey) => {
    throwIfAppliedToNonStaticProperty(klass, 'computed', propertyKey);

    const propertyObject = getPolymerPropertyObject(klass, propertyKey);

    const getterFunctionName = `__get_${propertyKey}_value`;
    const computedString = `${getterFunctionName}(${observedProps})`;

    klass.prototype[getterFunctionName] = computedFn;

    const config = {computed: computedString};

    Object.assign(propertyObject, config);
  };
}
