import {throwIfAppliedToNonPrototypeProperty} from './utils';

export function eventListener(eventType, options) {
  return (target, functionKey) => {
    throwIfAppliedToNonPrototypeProperty(target, 'eventListener', functionKey);

    if (target.ready._listeners) {
      target.ready._listeners.push({eventType, functionKey, options});
      return;
    }

    const ready = target.ready;

    target.ready = function addEventListenersOnReady(...args) {
      ready.apply(this, args);
      target.ready._listeners.forEach((v) =>
          this.addEventListener(v.eventType, this[v.functionKey], v.options),
      );
    };

    target.ready._listeners = [{eventType, functionKey, options}];
  };
}
