import {throwIfAppliedToNonStaticProperty, getPolymerPropertyObject} from './utils';

export function property(...args) {
  let propertyConfig = {};
  if (args.length === 3) {
    return decorate(...args);
  }
  propertyConfig = args[0];
  return decorate;

  function decorate(klass, propertyKey, desc) {
    throwIfAppliedToNonStaticProperty(klass, 'property', propertyKey);

    const propertyObject = getPolymerPropertyObject(klass, propertyKey);

    Object.assign(
      propertyObject,
      {value: desc.initializer ? desc.initializer() : void(0)},
      propertyConfig,
    );
  };
}
