import {throwIfAppliedToNonStaticProperty, getPolymerPropertyObject} from './utils';

export function routerStateParameter(stateParameter, options = {}) {
  return (klass, propertyKey) => {
    throwIfAppliedToNonStaticProperty(klass, 'routerStateParameter', propertyKey);

    const propertyObject = getPolymerPropertyObject(klass, propertyKey);

    const config = {stateParameter};
    if (options.reflectToState) {
      config.reflectToState = true;
      config.notify = true;
    }

    Object.assign(propertyObject, config);
  };
}
